xfs: convert tests to SPDX license tags
[xfstests-dev.git] / tests / xfs / 117
1 #! /bin/bash
2 # SPDX-License-Identifier: GPL-2.0
3 # Copyright (c) 2015 Oracle, Inc.  All Rights Reserved.
4 #
5 # FS QA Test No. 117
6 #
7 # Create and populate an XFS filesystem, corrupt an inode, then see how
8 # the kernel and xfs_repair deal with it.
9 #
10 seq=`basename $0`
11 seqres=$RESULT_DIR/$seq
12 echo "QA output created by $seq"
13
14 here=`pwd`
15 tmp=/tmp/$$
16 status=1        # failure is the default!
17 trap "_cleanup; exit \$status" 0 1 2 3 15
18
19 _cleanup()
20 {
21     cd /
22     #rm -f $tmp.*
23 }
24
25 # get standard environment, filters and checks
26 . ./common/rc
27 . ./common/filter
28 . ./common/attr
29 . ./common/populate
30
31 # real QA test starts here
32 _supported_fs xfs
33 _supported_os Linux
34
35 _require_scratch
36 test -n "${FORCE_FUZZ}" || _require_scratch_xfs_crc
37 _require_attrs
38 _require_populate_commands
39 _require_xfs_db_blocktrash_z_command
40 test -z "${FUZZ_ARGS}" && FUZZ_ARGS="-n 8 -3"
41
42 rm -f $seqres.full
43 TESTDIR="${SCRATCH_MNT}/scratchdir"
44 TESTFILE="${TESTDIR}/testfile"
45
46 echo "+ create scratch fs"
47 _scratch_mkfs_xfs > /dev/null
48
49 echo "+ mount fs image"
50 _scratch_mount
51 blksz="$(stat -f -c '%s' "${SCRATCH_MNT}")"
52
53 echo "+ make some files"
54 mkdir -p "${TESTDIR}"
55 for x in `seq 1 1024`; do
56         touch "${SCRATCH_MNT}/junk.${x}"
57         inode="$(stat -c '%i' "${SCRATCH_MNT}/junk.${x}")"
58         if [ "$x" -gt 512 ] && [ "$((inode % 64))" -eq 0 ]; then
59                 mv "${SCRATCH_MNT}/junk.${x}" "${TESTFILE}.1"
60                 break
61         fi
62 done
63 for x in `seq 2 64`; do
64         touch "${TESTFILE}.${x}"
65 done
66 inode="$(stat -c '%i' "${TESTFILE}.1")"
67 umount "${SCRATCH_MNT}"
68
69 echo "+ check fs"
70 _scratch_xfs_repair -n >> $seqres.full 2>&1 || _fail "xfs_repair should not fail"
71
72 echo "+ corrupt image"
73 seq "${inode}" "$((inode + 64))" | while read ino; do
74         _scratch_xfs_db -x -c "inode ${ino}" -c "stack" -c "blocktrash -x 32 -y $((blksz * 8)) -z ${FUZZ_ARGS}" >> $seqres.full 2>&1
75 done
76
77 echo "+ mount image"
78 if _try_scratch_mount >> $seqres.full 2>&1; then
79
80         echo "+ modify files"
81         broken=0
82         for x in `seq 1 64`; do
83                 stat "${TESTFILE}.${x}" >> $seqres.full 2>&1
84                 test $? -ne 0 && broken=1
85                 touch "${TESTFILE}.${x}" >> $seqres.full 2>&1
86                 test $? -ne 0 && broken=1
87         done
88         echo "broken: ${broken}"
89         umount "${SCRATCH_MNT}"
90 fi
91
92 echo "+ repair fs"
93 _scratch_xfs_repair >> $seqres.full 2>&1
94
95 echo "+ mount image (2)"
96 _scratch_mount
97
98 echo "+ chattr -R -i"
99 $CHATTR_PROG -R -f -i "${SCRATCH_MNT}/"
100
101 echo "+ modify files (2)"
102 broken=0
103 for x in `seq 1 64`; do
104         test -e "${TESTFILE}.${x}" || continue
105         echo "test ${x}" >> $seqres.full
106         stat "${TESTFILE}.${x}" >> $seqres.full 2>&1
107         test $? -ne 0 && broken=1
108         touch "${TESTFILE}.${x}" >> $seqres.full 2>&1
109         test $? -ne 0 && broken=1
110         echo "${x}: broken=${broken}" >> $seqres.full
111 done
112 echo "broken: ${broken}"
113 umount "${SCRATCH_MNT}"
114
115 echo "+ check fs (2)"
116 _scratch_xfs_repair -n >> $seqres.full 2>&1 || _fail "xfs_repair should not fail"
117
118 status=0
119 exit